local L = AceLibrary("AceLocale-2.2"):new("sRaidFrames")
local BS = AceLibrary("Babble-Spell-2.2")
local RL = AceLibrary("Roster-2.1")

local CastCommLib = CastCommLib
local sRaidFrames = sRaidFrames

local watchSpells = {
	[BS["Holy Light"]] = true,
	[BS["Flash of Light"]] = true,
	[BS["Flash Heal"]] = true,
	[BS["Greater Heal"]] = true,
	[BS["Heal"]] = true,
	[BS["Healing Touch"]] = true,
	[BS["Lesser Healing Wave"]] = true,
	[BS["Healing Wave"]] = true,
	[BS["Regrowth"]] = true,
	[BS["Prayer of Healing"]] = true,
}


function sRaidFrames:UnitGettingHealed(unit, castTime)
	if not self.opt.HighlightHeals or not self:IsTracking(unit) then return end
	if not castTime then 
		castTime = 2
	end
	
	self:SetStatus("Border", unit, "Heal", {r = 0, g = 1, b = 0}, "Incomming heal")
	
	self:ScheduleEvent("Heal_".. unit, self.HealCompleted, castTime, self, unit)
end

function sRaidFrames:GroupGettingHealed(healerUnit, castTime)
	local u1 = RL:GetUnitObjectFromUnit(healerUnit)
	if not u1 then return end

	for u2 in RL:IterateRoster() do
		if u2.subgroup == u1.subgroup then
			self:UnitGettingHealed(u2.unitid, castTime)
		end
	end
end

function sRaidFrames:HealCompleted(unit)
	self:UnsetStatus("Border", unit, "Heal")
	self:CancelScheduledEvent("Heal_".. unit)
end

function sRaidFrames:CastCommCallback(sender, senderUnit, action, target, channel, spell, rank, displayName, icon, startTime, endTime, isTradeSkill)
	self.CastCommUser[senderUnit] = true
	if not watchSpells[spell] or not target then return end
	if not self.opt.HighlightHealsSelf and UnitIsUnit(senderUnit, "player") then return end
	local castTime = (endTime-startTime)/1000
	
	if action == "START" then
		sender = RL:GetUnitIDFromName(sender)
		target = RL:GetUnitIDFromName(target)
		if spell == BS["Prayer of Healing"] then
			self:GroupGettingHealed(sender, castTime)
		else
			self:UnitGettingHealed(target, castTime)
		end
	--elseif action == "INTERRUPTED" or action == "FAILED" then
	--	target = RL:GetUnitIDFromName(target)
	--	self:CancelScheduledEvent("Heal_".. target)
	--	self:HealCompleted(target)
	end
end
